DROP TABLE STOCKPRICE CASCADE CONSTRAINTS;
CREATE TABLE STOCKPRICE (
    SYMBOL VARCHAR(16) not null,
    PRICEDATE DATE not null,
    LOW DECIMAL(30,2) not null,
    HIGH DECIMAL(30,2) not null,
    OPENINGPRICE NUMERIC(30,2) not null,
    CLOSINGPRICE NUMERIC(30,2) not null,
    ISYEARHIGH INTEGER,
    ISYEARLOW INTEGER,
    primary key (symbol, pricedate)
);

DROP TABLE STOCKOPTIONPRICE;
CREATE TABLE STOCKOPTIONPRICE (
    PRICE NUMERIC(30,2) not null,
    EXPIRATIONPERIOD INTEGER,
    PRICEDATE DATE not null,
    SYMBOL VARCHAR(16) not null,
    primary key (symbol, pricedate, expirationperiod),
    CONSTRAINT FK_OPTION
        FOREIGN KEY (PRICEDATE, SYMBOL)
	REFERENCES STOCKPRICE (PRICEDATE, SYMBOL)
);
